# -*- coding: utf-8 -*-
# $Id: storagecomponent.py 2969 2010-01-25 14:31:42Z anton $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-8.2.0/src/storagecomponent.py $
from merescocore.components import StorageComponent
from lxml.etree import parse, tostring

# FIXME namespaces uit configuratie
nsMap = {
    'acis' : 'http://acis.openlib.org/',
    'amf': 'http://amf.openlib.org',
    'ddi'  :"http://www.icpsr.umich.edu/DDI",
    'didl' :"urn:mpeg:mpeg21:2002:02-DIDL-NS",
    'dip'  :"urn:mpeg:mpeg21:2005:01-DIP-NS",
    'mods' :"http://www.loc.gov/mods/v3",
    'rdf'  :"http://www.w3.org/1999/02/22-rdf-syntax-ns#",
    'extra':"http://meresco.com/namespace/fields/extra",
    'meta' :"http://meresco.com/namespace/harvester/meta"
}

class BZVStorageComponent(StorageComponent):
#    def add(self, id, partName, someString):
#        """should be obsoleted in favor of addDocumentPart"""
#        id = self.escape(id)
#        sink = self._storage.put((id, partName))
#        try:
#            sink.send(someString)
#        finally:
#            return sink.close()

    def yieldRecord(self, id, partName):
#        id = self.escape(id)
        isAvailable = self.isAvailable(id, partName)
        if isAvailable == (True, True):
            stream = self._storage.get((id, partName))
            for data in stream:
                yield data
            stream.close()
        elif isAvailable == (True, False):
            metadata = parse(self.getStream(id, "metadata"))
            data = metadata.xpath("//" + partName + ":" + partName, namespaces=nsMap)[0]
            yield tostring(data)

#    def escape(self, id):
#        id = id.replace('(', '%28')
#        id = id.replace(')', '%29')
#        id = id.replace('/', '%2F')
#        return id
